summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorDavid P <megver83@parabola.nu>2020-08-01 15:11:02 -0400
committerDavid P <megver83@parabola.nu>2020-08-01 15:11:02 -0400
commite03b9539e946803923267b1e60bfc450b5a918f9 (patch)
treedaa52ea0fbcd261961ac75279e716c2d578f5b42
parentd1e535ec9761cc78c95ea756d470fb68f8b25109 (diff)
sync mkparabolaiso and initcpios with archiso v46
Signed-off-by: David P <megver83@parabola.nu>
-rw-r--r--parabolaiso/initcpio/hooks/parabolaiso117
-rw-r--r--parabolaiso/initcpio/hooks/parabolaiso_loop_mnt32
-rw-r--r--parabolaiso/initcpio/hooks/parabolaiso_pxe_common62
-rw-r--r--parabolaiso/initcpio/hooks/parabolaiso_pxe_http32
-rw-r--r--parabolaiso/initcpio/hooks/parabolaiso_pxe_nbd30
-rw-r--r--parabolaiso/initcpio/hooks/parabolaiso_pxe_nfs32
-rw-r--r--parabolaiso/initcpio/hooks/parabolaiso_shutdown6
-rw-r--r--parabolaiso/initcpio/install/parabolaiso12
-rw-r--r--parabolaiso/initcpio/install/parabolaiso_kms6
-rw-r--r--parabolaiso/initcpio/install/parabolaiso_loop_mnt6
-rw-r--r--parabolaiso/initcpio/install/parabolaiso_pxe_common16
-rw-r--r--parabolaiso/initcpio/install/parabolaiso_pxe_http8
-rw-r--r--parabolaiso/initcpio/install/parabolaiso_pxe_nbd6
-rw-r--r--parabolaiso/initcpio/install/parabolaiso_pxe_nfs6
-rw-r--r--parabolaiso/initcpio/install/parabolaiso_shutdown10
-rw-r--r--parabolaiso/initcpio/script/parabolaiso_shutdown14
-rwxr-xr-xparabolaiso/mkparabolaiso14
17 files changed, 245 insertions, 164 deletions
diff --git a/parabolaiso/initcpio/hooks/parabolaiso b/parabolaiso/initcpio/hooks/parabolaiso
index 6499310..975894f 100644
--- a/parabolaiso/initcpio/hooks/parabolaiso
+++ b/parabolaiso/initcpio/hooks/parabolaiso
@@ -1,3 +1,7 @@
+#!/bin/ash
+#
+# SPDX-License-Identifier: GPL-3.0-or-later
+
# args: source, newroot, mountpoint
_mnt_dmsnapshot() {
local img="${1}"
@@ -8,19 +12,19 @@ _mnt_dmsnapshot() {
local dm_snap_name="${dm_snap_prefix}_${img_name}"
local ro_dev ro_dev_size rw_dev
- ro_dev=$(losetup --find --show --read-only "${img}")
- echo ${ro_dev} >> /run/parabolaiso/used_block_devices
- ro_dev_size=$(blockdev --getsz ${ro_dev})
+ ro_dev="$(losetup --find --show --read-only -- "${img}")"
+ echo "${ro_dev}" >> /run/parabolaiso/used_block_devices
+ ro_dev_size="$(blockdev --getsz -- "${ro_dev}")"
- if [[ "${cow_persistent}" == "P" ]]; then
- if [[ -f "/run/parabolaiso/cowspace/${cow_directory}/${img_name}.cow" ]]; then
+ if [ "${cow_persistent}" = "P" ]; then
+ if [ -f "/run/parabolaiso/cowspace/${cow_directory}/${img_name}.cow" ]; then
msg ":: Found '/run/parabolaiso/cowspace/${cow_directory}/${img_name}.cow', using as persistent."
else
msg ":: Creating '/run/parabolaiso/cowspace/${cow_directory}/${img_name}.cow' as persistent."
truncate -s "${cow_spacesize}" "/run/parabolaiso/cowspace/${cow_directory}/${img_name}.cow"
fi
else
- if [[ -f "/run/parabolaiso/cowspace/${cow_directory}/${img_name}.cow" ]]; then
+ if [ -f "/run/parabolaiso/cowspace/${cow_directory}/${img_name}.cow" ]; then
msg ":: Found '/run/parabolaiso/cowspace/${cow_directory}/${img_name}.cow' but non-persistent requested, removing."
rm -f "/run/parabolaiso/cowspace/${cow_directory}/${img_name}.cow"
fi
@@ -28,17 +32,18 @@ _mnt_dmsnapshot() {
truncate -s "${cow_spacesize}" "/run/parabolaiso/cowspace/${cow_directory}/${img_name}.cow"
fi
- rw_dev=$(losetup --find --show "/run/parabolaiso/cowspace/${cow_directory}/${img_name}.cow")
- echo ${rw_dev} >> /run/parabolaiso/used_block_devices
+ rw_dev="$(losetup --find --show "/run/parabolaiso/cowspace/${cow_directory}/${img_name}.cow")"
+ echo "${rw_dev}" >> /run/parabolaiso/used_block_devices
- dmsetup create ${dm_snap_name} --table "0 ${ro_dev_size} snapshot ${ro_dev} ${rw_dev} ${cow_persistent} ${cow_chunksize}"
+ dmsetup create "${dm_snap_name}" --table \
+ "0 ${ro_dev_size} snapshot ${ro_dev} ${rw_dev} ${cow_persistent} ${cow_chunksize}"
- if [[ "${cow_persistent}" != "P" ]]; then
+ if [ "${cow_persistent}" != "P" ]; then
rm -f "/run/parabolaiso/cowspace/${cow_directory}/${img_name}.cow"
fi
_mnt_dev "/dev/mapper/${dm_snap_name}" "${newroot}${mnt}" "-w" "defaults"
- echo $(readlink -f /dev/mapper/${dm_snap_name}) >> /run/parabolaiso/used_block_devices
+ readlink -f "/dev/mapper/${dm_snap_name}" >> /run/parabolaiso/used_block_devices
}
# args: source, newroot, mountpoint
@@ -46,8 +51,10 @@ _mnt_overlayfs() {
local src="${1}"
local newroot="${2}"
local mnt="${3}"
- mkdir -p /run/parabolaiso/cowspace/${cow_directory}/upperdir /run/parabolaiso/cowspace/${cow_directory}/workdir
- mount -t overlay -o lowerdir=${src},upperdir=/run/parabolaiso/cowspace/${cow_directory}/upperdir,workdir=/run/parabolaiso/cowspace/${cow_directory}/workdir airootfs "${newroot}${mnt}"
+ mkdir -p "/run/parabolaiso/cowspace/${cow_directory}/upperdir" "/run/parabolaiso/cowspace/${cow_directory}/workdir"
+ mount -t overlay -o \
+ "lowerdir=${src},upperdir=/run/parabolaiso/cowspace/${cow_directory}/upperdir,workdir=/run/parabolaiso/cowspace/${cow_directory}/workdir" \
+ airootfs "${newroot}${mnt}"
}
@@ -58,17 +65,19 @@ _mnt_sfs() {
local img_fullname="${img##*/}"
local sfs_dev
- if [[ "${copytoram}" == "y" ]]; then
+ # shellcheck disable=SC2154
+ # defined via initcpio's parse_cmdline()
+ if [ "${copytoram}" = "y" ]; then
msg -n ":: Copying squashfs image to RAM..."
- if ! cp "${img}" "/run/parabolaiso/copytoram/${img_fullname}" ; then
+ if ! cp -- "${img}" "/run/parabolaiso/copytoram/${img_fullname}" ; then
echo "ERROR: while copy '${img}' to '/run/parabolaiso/copytoram/${img_fullname}'"
launch_interactive_shell
fi
img="/run/parabolaiso/copytoram/${img_fullname}"
msg "done."
fi
- sfs_dev=$(losetup --find --show --read-only "${img}")
- echo ${sfs_dev} >> /run/parabolaiso/used_block_devices
+ sfs_dev="$(losetup --find --show --read-only -- "${img}")"
+ echo "${sfs_dev}" >> /run/parabolaiso/used_block_devices
_mnt_dev "${sfs_dev}" "${mnt}" "-r" "defaults"
}
@@ -102,45 +111,48 @@ _mnt_dev() {
_verify_checksum() {
local _status
- cd "/run/parabolaiso/bootmnt/${parabolaisobasedir}/${arch}"
+ cd "/run/parabolaiso/bootmnt/${parabolaisobasedir}/${arch}" || exit 1
sha512sum -c airootfs.sha512 > /tmp/checksum.log 2>&1
_status=$?
- cd "${OLDPWD}"
- return ${_status}
+ cd -- "${OLDPWD}" || exit 1
+ return "${_status}"
}
_verify_signature() {
local _status
- cd "/run/parabolaiso/bootmnt/${parabolaisobasedir}/${arch}"
+ cd "/run/parabolaiso/bootmnt/${parabolaisobasedir}/${arch}" || exit 1
gpg --homedir /gpg --status-fd 1 --verify airootfs.sfs.sig 2>/dev/null | grep -qE '^\[GNUPG:\] GOODSIG'
_status=$?
- cd "${OLDPWD}"
+ cd -- "${OLDPWD}" || exit 1
return ${_status}
}
run_hook() {
- [[ -z "${arch}" ]] && arch="$(uname -m)"
- [[ -z "${copytoram_size}" ]] && copytoram_size="75%"
- [[ -z "${parabolaisobasedir}" ]] && parabolaisobasedir="parabola"
- [[ -z "${dm_snap_prefix}" ]] && dm_snap_prefix="parabola"
- [[ -z "${parabolaisodevice}" ]] && parabolaisodevice="/dev/disk/by-label/${parabolaisolabel}"
- [[ -z "${cow_spacesize}" ]] && cow_spacesize="256M"
-
- if [[ -n "${cow_label}" ]]; then
+ [ -z "${arch}" ] && arch="$(uname -m)"
+ [ -z "${copytoram_size}" ] && copytoram_size="75%"
+ [ -z "${parabolaisobasedir}" ] && parabolaisobasedir="arch"
+ [ -z "${dm_snap_prefix}" ] && dm_snap_prefix="arch"
+ # shellcheck disable=SC2154
+ # defined via initcpio's parse_cmdline()
+ [ -z "${parabolaisodevice}" ] && parabolaisodevice="/dev/disk/by-label/${parabolaisolabel}"
+ [ -z "${cow_spacesize}" ] && cow_spacesize="256M"
+ # shellcheck disable=SC2154
+ # defined via initcpio's parse_cmdline()
+ if [ -n "${cow_label}" ]; then
cow_device="/dev/disk/by-label/${cow_label}"
- [[ -z "${cow_persistent}" ]] && cow_persistent="P"
- elif [[ -n "${cow_device}" ]]; then
- [[ -z "${cow_persistent}" ]] && cow_persistent="P"
+ [ -z "${cow_persistent}" ] && cow_persistent="P"
+ elif [ -n "${cow_device}" ]; then
+ [ -z "${cow_persistent}" ] && cow_persistent="P"
else
cow_persistent="N"
fi
- [[ -z "${cow_flags}" ]] && cow_flags="defaults"
- [[ -z "${cow_directory}" ]] && cow_directory="persistent_${parabolaisolabel}/${arch}"
- [[ -z "${cow_chunksize}" ]] && cow_chunksize="8"
+ [ -z "${cow_flags}" ] && cow_flags="defaults"
+ [ -z "${cow_directory}" ] && cow_directory="persistent_${parabolaisolabel}/${arch}"
+ [ -z "${cow_chunksize}" ] && cow_chunksize="8"
# set mount handler for parabolaiso
- mount_handler="parabolaiso_mount_handler"
+ export mount_handler="parabolaiso_mount_handler"
}
# This function is called normally from init script, but it can be called
@@ -151,13 +163,15 @@ parabolaiso_mount_handler() {
if ! mountpoint -q "/run/parabolaiso/bootmnt"; then
_mnt_dev "${parabolaisodevice}" "/run/parabolaiso/bootmnt" "-r" "defaults"
- if [[ "${copytoram}" != "y" ]]; then
- echo $(readlink -f ${parabolaisodevice}) >> /run/parabolaiso/used_block_devices
+ if [ "${copytoram}" != "y" ]; then
+ readlink -f "${parabolaisodevice}" >> /run/parabolaiso/used_block_devices
fi
fi
- if [[ "${checksum}" == "y" ]]; then
- if [[ -f "/run/parabolaiso/bootmnt/${parabolaisobasedir}/${arch}/airootfs.sha512" ]]; then
+ # shellcheck disable=SC2154
+ # defined via initcpio's parse_cmdline()
+ if [ "${checksum}" = "y" ]; then
+ if [ -f "/run/parabolaiso/bootmnt/${parabolaisobasedir}/${arch}/airootfs.sha512" ]; then
msg -n ":: Self-test requested, please wait..."
if _verify_checksum; then
msg "done. Checksum is OK, continue booting."
@@ -172,8 +186,10 @@ parabolaiso_mount_handler() {
fi
fi
- if [[ "${verify}" == "y" ]]; then
- if [[ -f "/run/parabolaiso/bootmnt/${parabolaisobasedir}/${arch}/airootfs.sfs.sig" ]]; then
+ # shellcheck disable=SC2154
+ # defined via initcpio's parse_cmdline()
+ if [ "${verify}" = "y" ]; then
+ if [ -f "/run/parabolaiso/bootmnt/${parabolaisobasedir}/${arch}/airootfs.sfs.sig" ]; then
msg -n ":: Signature verification requested, please wait..."
if _verify_signature; then
msg "done. Signature is OK, continue booting."
@@ -187,33 +203,34 @@ parabolaiso_mount_handler() {
fi
fi
- if [[ "${copytoram}" == "y" ]]; then
+ if [ "${copytoram}" = "y" ]; then
msg ":: Mounting /run/parabolaiso/copytoram (tmpfs) filesystem, size=${copytoram_size}"
mkdir -p /run/parabolaiso/copytoram
mount -t tmpfs -o "size=${copytoram_size}",mode=0755 copytoram /run/parabolaiso/copytoram
fi
- if [[ -n "${cow_device}" ]]; then
+ if [ -n "${cow_device}" ]; then
_mnt_dev "${cow_device}" "/run/parabolaiso/cowspace" "-r" "${cow_flags}"
- echo $(readlink -f ${cow_device}) >> /run/parabolaiso/used_block_devices
+ readlink -f "${cow_device}" >> /run/parabolaiso/used_block_devices
mount -o remount,rw "/run/parabolaiso/cowspace"
else
msg ":: Mounting /run/parabolaiso/cowspace (tmpfs) filesystem, size=${cow_spacesize}..."
mkdir -p /run/parabolaiso/cowspace
mount -t tmpfs -o "size=${cow_spacesize}",mode=0755 cowspace /run/parabolaiso/cowspace
fi
- mkdir -p -m 0700 "/run/parabolaiso/cowspace/${cow_directory}"
+ mkdir -p "/run/parabolaiso/cowspace/${cow_directory}"
+ chmod 0700 "/run/parabolaiso/cowspace/${cow_directory}"
_mnt_sfs "/run/parabolaiso/bootmnt/${parabolaisobasedir}/${arch}/airootfs.sfs" "/run/parabolaiso/sfs/airootfs"
- if [[ -f "/run/parabolaiso/sfs/airootfs/airootfs.img" ]]; then
+ if [ -f "/run/parabolaiso/sfs/airootfs/airootfs.img" ]; then
_mnt_dmsnapshot "/run/parabolaiso/sfs/airootfs/airootfs.img" "${newroot}" "/"
else
_mnt_overlayfs "/run/parabolaiso/sfs/airootfs" "${newroot}" "/"
fi
- if [[ "${copytoram}" == "y" ]]; then
+ if [ "${copytoram}" = "y" ]; then
umount -d /run/parabolaiso/bootmnt
fi
}
-# vim:ft=sh:ts=4:sw=4:et:
+# vim: set ft=sh:
diff --git a/parabolaiso/initcpio/hooks/parabolaiso_loop_mnt b/parabolaiso/initcpio/hooks/parabolaiso_loop_mnt
index 1a8783d..f76d204 100644
--- a/parabolaiso/initcpio/hooks/parabolaiso_loop_mnt
+++ b/parabolaiso/initcpio/hooks/parabolaiso_loop_mnt
@@ -1,10 +1,16 @@
-# vim: set ft=sh:
+#!/bin/ash
+#
+# SPDX-License-Identifier: GPL-3.0-or-later
run_hook () {
- [[ -n "${img_label}" ]] && img_dev="/dev/disk/by-label/${img_label}"
- [[ -z "${img_flags}" ]] && img_flags="defaults"
- if [[ -n "${img_dev}" && -n "${img_loop}" ]]; then
- mount_handler="parabolaiso_loop_mount_handler"
+ # shellcheck disable=SC2154
+ # defined via initcpio's parse_cmdline()
+ [ -n "${img_label}" ] && img_dev="/dev/disk/by-label/${img_label}"
+ [ -z "${img_flags}" ] && img_flags="defaults"
+ # shellcheck disable=SC2154
+ # defined via initcpio's parse_cmdline()
+ if [ -n "${img_dev}" ] && [ -n "${img_loop}" ]; then
+ export mount_handler="parabolaiso_loop_mount_handler"
fi
}
@@ -15,21 +21,25 @@ parabolaiso_loop_mount_handler () {
msg ":: Setup a loop device from ${img_loop} located at device ${img_dev}"
_mnt_dev "${img_dev}" "/run/parabolaiso/img_dev" "-r" "${img_flags}"
- if [[ "${copytoram}" != "y" ]]; then
- echo $(readlink -f ${img_dev}) >> /run/parabolaiso/used_block_devices
+ # shellcheck disable=SC2154
+ # defined via initcpio's parse_cmdline()
+ if [ "${copytoram}" != "y" ]; then
+ readlink -f "${img_dev}" >> /run/parabolaiso/used_block_devices
fi
if _dev_loop=$(losetup --find --show --read-only "/run/parabolaiso/img_dev/${img_loop}"); then
- parabolaisodevice="${_dev_loop}"
+ export parabolaisodevice="${_dev_loop}"
else
echo "ERROR: Setting loopback device for file '/run/parabolaiso/img_dev/${img_loop}'"
launch_interactive_shell
fi
- parabolaiso_mount_handler ${newroot}
+ parabolaiso_mount_handler "${newroot}"
- if [[ "${copytoram}" == "y" ]]; then
- losetup -d ${_dev_loop} 2>/dev/null
+ if [ "${copytoram}" = "y" ]; then
+ losetup -d "${_dev_loop}" 2>/dev/null
umount /run/parabolaiso/img_dev
fi
}
+
+# vim: set ft=sh:
diff --git a/parabolaiso/initcpio/hooks/parabolaiso_pxe_common b/parabolaiso/initcpio/hooks/parabolaiso_pxe_common
index 7c3b1b5..035a3e9 100644
--- a/parabolaiso/initcpio/hooks/parabolaiso_pxe_common
+++ b/parabolaiso/initcpio/hooks/parabolaiso_pxe_common
@@ -1,55 +1,59 @@
-# vim: set ft=sh:
+#!/bin/ash
+#
+# SPDX-License-Identifier: GPL-3.0-or-later
run_hook () {
# Do *not* declare 'bootif_dev' local! We need it in run_latehook().
local i net_mac bootif_mac
+ local DNSDOMAIN HOSTNAME IPV4DNS0 IPV4DNS1 ROOTSERVER
# These variables will be parsed from /tmp/net-*.conf generated by ipconfig
- local DEVICE
- local IPV4ADDR IPV4BROADCAST IPV4NETMASK IPV4GATEWAY IPV4DNS0 IPV4DNS1
- local HOSTNAME DNSDOMAIN NISDOMAIN ROOTSERVER ROOTPATH
- local filename
- # /tmp/net-*.conf
+ # shellcheck disable=SC2034
+ local DEVICE IPV4ADDR IPV4BROADCAST IPV4NETMASK IPV4GATEWAY NISDOMAIN ROOTPATH filename
- if [[ -n "${ip}" ]]; then
- if [[ -n "${BOOTIF}" ]]; then
- bootif_mac=${BOOTIF#01-}
- bootif_mac=${bootif_mac//-/:}
+ if [ -n "${ip}" ]; then
+ if [ -n "${BOOTIF}" ]; then
+ bootif_mac="${BOOTIF#01-}"
+ # shellcheck disable=SC2169
+ # ash supports bash-like string replacment
+ bootif_mac="${bootif_mac//-/:}"
for i in /sys/class/net/*/address; do
- read net_mac < ${i}
- if [[ "${bootif_mac}" == "${net_mac}" ]]; then
+ read -r net_mac < "${i}"
+ if [ "${bootif_mac}" = "${net_mac}" ]; then
bootif_dev=${i#/sys/class/net/}
bootif_dev=${bootif_dev%/address}
break
fi
done
- if [[ "${ip}" == "dhcp" ]]; then
+ if [ "${ip}" = "dhcp" ]; then
ip=":::::${bootif_dev}:dhcp"
- else
+ else
ip="${ip}::${bootif_dev}"
fi
fi
# setup network and save some values
if ! ipconfig -t 20 "ip=${ip}"; then
- echo "ERROR; Failed to configure network"
- echo " Falling back to interactive prompt"
- echo " You can try to fix the problem manually, log out when you are finished"
- launch_interactive_shell
+ echo "ERROR; Failed to configure network"
+ echo " Falling back to interactive prompt"
+ echo " You can try to fix the problem manually, log out when you are finished"
+ launch_interactive_shell
fi
+ # shellcheck disable=SC1090
+ # ipconfig generates these files
. /tmp/net-*.conf
- pxeserver=${ROOTSERVER}
+ export pxeserver="${ROOTSERVER}"
# setup DNS resolver
- if [[ "${IPV4DNS0}" != "0.0.0.0" ]]; then
+ if [ "${IPV4DNS0}" != "0.0.0.0" ]; then
echo "# added by parabolaiso_pxe_common hook" > /etc/resolv.conf
echo "nameserver ${IPV4DNS0}" >> /etc/resolv.conf
fi
- if [[ "${IPV4DNS1}" != "0.0.0.0" ]]; then
+ if [ "${IPV4DNS1}" != "0.0.0.0" ]; then
echo "nameserver ${IPV4DNS1}" >> /etc/resolv.conf
fi
- if [[ -n "${DNSDOMAIN}" ]]; then
+ if [ -n "${DNSDOMAIN}" ]; then
echo "search ${DNSDOMAIN}" >> /etc/resolv.conf
echo "domain ${DNSDOMAIN}" >> /etc/resolv.conf
fi
@@ -57,16 +61,20 @@ run_hook () {
}
run_latehook () {
- if [[ -n "${ip}" ]]; then
- [[ -z "${copy_resolvconf}" ]] && copy_resolvconf="y"
+ if [ -n "${ip}" ]; then
+ [ -z "${copy_resolvconf}" ] && copy_resolvconf="y"
- if [[ "${copytoram}" == "y" ]]; then
- if [[ -n "${bootif_dev}" ]]; then
+ # shellcheck disable=SC2154
+ # defined via initcpio's parse_cmdline()
+ if [ "${copytoram}" = "y" ]; then
+ if [ -n "${bootif_dev}" ]; then
ip addr flush dev "${bootif_dev}"
ip link set "${bootif_dev}" down
fi
- elif [[ "${copy_resolvconf}" != "n" && -f /etc/resolv.conf ]]; then
+ elif [ "${copy_resolvconf}" != "n" ] && [ -f /etc/resolv.conf ]; then
cp /etc/resolv.conf /new_root/etc/resolv.conf
fi
fi
}
+
+# vim: set ft=sh:
diff --git a/parabolaiso/initcpio/hooks/parabolaiso_pxe_http b/parabolaiso/initcpio/hooks/parabolaiso_pxe_http
index b3440ed..1fbd921 100644
--- a/parabolaiso/initcpio/hooks/parabolaiso_pxe_http
+++ b/parabolaiso/initcpio/hooks/parabolaiso_pxe_http
@@ -1,16 +1,20 @@
-# vim: set ft=sh:
+#!/bin/ash
+#
+# SPDX-License-Identifier: GPL-3.0-or-later
run_hook() {
- if [[ -n "${ip}" && -n "${parabolaiso_http_srv}" ]]; then
+ # shellcheck disable=SC2154
+ # defined via initcpio's parse_cmdline()
+ if [ -n "${ip}" ] && [ -n "${parabolaiso_http_srv}" ]; then
# booting with http is always copy-to-ram, so set here to make sure
# addresses are flushed and interface is set down
- copytoram="y"
+ export copytoram="y"
- parabolaiso_http_srv=$(eval echo ${parabolaiso_http_srv})
- [[ -z "${parabolaiso_http_spc}" ]] && parabolaiso_http_spc="75%"
+ parabolaiso_http_srv=$(eval echo "${parabolaiso_http_srv}")
+ [ -z "${parabolaiso_http_spc}" ] && parabolaiso_http_spc="75%"
- mount_handler="parabolaiso_pxe_http_mount_handler"
+ export mount_handler="parabolaiso_pxe_http_mount_handler"
fi
}
@@ -23,6 +27,8 @@ _curl_get() {
local _dst="${2}"
msg ":: Downloading '${_url}'"
+ # shellcheck disable=SC2154
+ # defined via initcpio's parse_cmdline()
if ! curl -L -f -o "/run/parabolaiso/httpspace/${parabolaisobasedir}${_dst}/${_url##*/}" --create-dirs "${_url}"; then
echo "ERROR: Downloading '${_url}'"
echo " Falling back to interactive prompt"
@@ -38,17 +44,25 @@ parabolaiso_pxe_http_mount_handler () {
mkdir -p "/run/parabolaiso/httpspace"
mount -t tmpfs -o size="${parabolaiso_http_spc}",mode=0755 httpspace "/run/parabolaiso/httpspace"
+ # shellcheck disable=SC2154
+ # defined via initcpio's parse_cmdline()
_curl_get "${parabolaiso_http_srv}${parabolaisobasedir}/${arch}/airootfs.sfs" "/${arch}"
- if [[ "${checksum}" == "y" ]]; then
+ # shellcheck disable=SC2154
+ # defined via initcpio's parse_cmdline()
+ if [ "${checksum}" = "y" ]; then
_curl_get "${parabolaiso_http_srv}${parabolaisobasedir}/${arch}/airootfs.sha512" "/${arch}"
fi
- if [[ "${verify}" == "y" ]]; then
+ # shellcheck disable=SC2154
+ # defined via initcpio's parse_cmdline()
+ if [ "${verify}" = "y" ]; then
_curl_get "${parabolaiso_http_srv}${parabolaisobasedir}/${arch}/airootfs.sfs.sig" "/${arch}"
fi
mkdir -p "/run/parabolaiso/bootmnt"
mount -o bind /run/parabolaiso/httpspace /run/parabolaiso/bootmnt
- parabolaiso_mount_handler ${newroot}
+ parabolaiso_mount_handler "${newroot}"
}
+
+# vim: set ft=sh:
diff --git a/parabolaiso/initcpio/hooks/parabolaiso_pxe_nbd b/parabolaiso/initcpio/hooks/parabolaiso_pxe_nbd
index 1991f80..b8c1e53 100644
--- a/parabolaiso/initcpio/hooks/parabolaiso_pxe_nbd
+++ b/parabolaiso/initcpio/hooks/parabolaiso_pxe_nbd
@@ -1,19 +1,23 @@
-# vim: set ft=sh:
+#!/bin/ash
+#
+# SPDX-License-Identifier: GPL-3.0-or-later
run_earlyhook() {
- if [[ -n "${ip}" && -n "${parabolaiso_nbd_srv}" ]]; then
+ # shellcheck disable=SC2154
+ # defined via initcpio's parse_cmdline()
+ if [ -n "${ip}" ] && [ -n "${parabolaiso_nbd_srv}" ]; then
# Module autoloading like with loop devices does not work, doing manually...
modprobe nbd 2> /dev/null
fi
}
run_hook() {
- if [[ -n "${ip}" && -n "${parabolaiso_nbd_srv}" ]]; then
+ if [ -n "${ip}" ] && [ -n "${parabolaiso_nbd_srv}" ]; then
- parabolaiso_nbd_srv=$(eval echo ${parabolaiso_nbd_srv})
- [[ -z "${parabolaiso_nbd_name}" ]] && parabolaiso_nbd_name="parabolaiso"
+ parabolaiso_nbd_srv=$(eval echo "${parabolaiso_nbd_srv}")
+ [ -z "${parabolaiso_nbd_name}" ] && parabolaiso_nbd_name="parabolaiso"
- mount_handler="parabolaiso_pxe_nbd_mount_handler"
+ export mount_handler="parabolaiso_pxe_nbd_mount_handler"
fi
}
@@ -29,19 +33,21 @@ parabolaiso_pxe_nbd_mount_handler () {
done
msg ":: Setup NBD from ${parabolaiso_nbd_srv} at /dev/nbd0"
- if [[ "${copytoram}" != "n" ]]; then
- nbd-client ${parabolaiso_nbd_srv} -N ${parabolaiso_nbd_name} /dev/nbd0
+ if [ "${copytoram}" != "n" ]; then
+ nbd-client "${parabolaiso_nbd_srv}" -N "${parabolaiso_nbd_name}" /dev/nbd0
copytoram="y"
else
- nbd-client ${parabolaiso_nbd_srv} -N ${parabolaiso_nbd_name} -systemd-mark -persist /dev/nbd0
+ nbd-client "${parabolaiso_nbd_srv}" -N "${parabolaiso_nbd_name}" -systemd-mark -persist /dev/nbd0
fi
- parabolaisodevice=/dev/nbd0
+ export parabolaisodevice=/dev/nbd0
- parabolaiso_mount_handler ${newroot}
+ parabolaiso_mount_handler "${newroot}"
- if [[ "${copytoram}" == "y" ]]; then
+ if [ "${copytoram}" = "y" ]; then
msg ":: Disconnect NBD from ${parabolaiso_nbd_srv} at /dev/nbd0"
nbd-client -d /dev/nbd0
fi
}
+
+# vim: set ft=sh:
diff --git a/parabolaiso/initcpio/hooks/parabolaiso_pxe_nfs b/parabolaiso/initcpio/hooks/parabolaiso_pxe_nfs
index 6eba5b7..815e33b 100644
--- a/parabolaiso/initcpio/hooks/parabolaiso_pxe_nfs
+++ b/parabolaiso/initcpio/hooks/parabolaiso_pxe_nfs
@@ -1,30 +1,44 @@
-# vim: set ft=sh:
+#!/bin/ash
+#
+# SPDX-License-Identifier: GPL-3.0-or-later
run_hook() {
- if [[ -n "${ip}" && -n "${parabolaiso_nfs_srv}" ]]; then
+ # shellcheck disable=SC2154
+ # defined via initcpio's parse_cmdline()
+ if [ -n "${ip}" ] && [ -n "${parabolaiso_nfs_srv}" ]; then
- parabolaiso_nfs_srv=$(eval echo ${parabolaiso_nfs_srv})
- [[ -n "${parabolaiso_nfs_opt}" ]] && parabolaiso_nfs_opt="-o ${parabolaiso_nfs_opt}"
+ parabolaiso_nfs_srv=$(eval echo "${parabolaiso_nfs_srv}")
- mount_handler="parabolaiso_nfs_mount_handler"
+ export mount_handler="parabolaiso_nfs_mount_handler"
fi
}
parabolaiso_nfs_mount_handler() {
+ local mount_status
newroot="${1}"
mkdir -p "/run/parabolaiso/bootmnt"
msg ":: Mounting '${parabolaiso_nfs_srv}'"
- # Do not put "${parabolaiso_nfs_opt}" nfsmount fails!
- if ! nfsmount ${parabolaiso_nfs_opt} "${parabolaiso_nfs_srv}" "/run/parabolaiso/bootmnt"; then
+ # shellcheck disable=SC2154
+ # defined via initcpio's parse_cmdline()
+ if [ -n "${parabolaiso_nfs_opt}" ]; then
+ nfsmount -o "${parabolaiso_nfs_opt}" "${parabolaiso_nfs_srv}" "/run/parabolaiso/bootmnt"
+ mount_status=$?
+ else
+ nfsmount "${parabolaiso_nfs_srv}" "/run/parabolaiso/bootmnt"
+ mount_status=$?
+ fi
+ if [ $mount_status -gt 0 ]; then
echo "ERROR: Mounting '${parabolaiso_nfs_srv}'"
echo " Falling back to interactive prompt"
echo " You can try to fix the problem manually, log out when you are finished"
launch_interactive_shell
fi
- if [[ "${copytoram}" != "n" ]]; then
+ if [ "${copytoram}" != "n" ]; then
copytoram="y"
fi
- parabolaiso_mount_handler ${newroot}
+ parabolaiso_mount_handler "${newroot}"
}
+
+# vim: set ft=sh:
diff --git a/parabolaiso/initcpio/hooks/parabolaiso_shutdown b/parabolaiso/initcpio/hooks/parabolaiso_shutdown
index e50dedb..ebb6b11 100644
--- a/parabolaiso/initcpio/hooks/parabolaiso_shutdown
+++ b/parabolaiso/initcpio/hooks/parabolaiso_shutdown
@@ -1,6 +1,10 @@
+#!/bin/ash
+#
+# SPDX-License-Identifier: GPL-3.0-or-later
+
run_cleanuphook() {
rm -rf /usr/lib/modules
cp -ax / /run/initramfs
}
-# vim: set ft=sh ts=4 sw=4 et:
+# vim: set ft=sh:
diff --git a/parabolaiso/initcpio/install/parabolaiso b/parabolaiso/initcpio/install/parabolaiso
index 30728ef..1e3b3b6 100644
--- a/parabolaiso/initcpio/install/parabolaiso
+++ b/parabolaiso/initcpio/install/parabolaiso
@@ -1,4 +1,6 @@
-#!/bin/bash
+#!/usr/bin/env bash
+#
+# SPDX-License-Identifier: GPL-3.0-or-later
build() {
add_module "cdrom"
@@ -21,10 +23,8 @@ build() {
add_file /usr/lib/udev/rules.d/10-dm.rules
add_file /usr/lib/udev/rules.d/95-dm-notify.rules
add_file /usr/lib/initcpio/udev/11-dm-initramfs.rules /usr/lib/udev/rules.d/11-dm-initramfs.rules
- if [[ $ARCHISO_GNUPG_FD ]]; then
- mkdir -p "$BUILDROOT$dest"/gpg
- gpg --homedir "$BUILDROOT$dest"/gpg --import <&$ARCHISO_GNUPG_FD
+ if [[ $PARABOLAISO_GNUPG_FD ]]; then
+ mkdir -m 0700 -- "$BUILDROOT/gpg"
+ gpg --homedir "$BUILDROOT/gpg" --import <& "$PARABOLAISO_GNUPG_FD"
fi
}
-
-# vim: set ft=sh ts=4 sw=4 et:
diff --git a/parabolaiso/initcpio/install/parabolaiso_kms b/parabolaiso/initcpio/install/parabolaiso_kms
index 3ff31f3..8129127 100644
--- a/parabolaiso/initcpio/install/parabolaiso_kms
+++ b/parabolaiso/initcpio/install/parabolaiso_kms
@@ -1,9 +1,13 @@
-#!/bin/bash
+#!/usr/bin/env bash
+#
+# SPDX-License-Identifier: GPL-3.0-or-later
build() {
+ add_module "amdgpu"
add_module "radeon"
add_module "nouveau"
add_module "i915"
+ add_module "mgag200"
add_module "via-agp"
add_module "sis-agp"
add_module "intel-agp"
diff --git a/parabolaiso/initcpio/install/parabolaiso_loop_mnt b/parabolaiso/initcpio/install/parabolaiso_loop_mnt
index 59f1d94..1f2c529 100644
--- a/parabolaiso/initcpio/install/parabolaiso_loop_mnt
+++ b/parabolaiso/initcpio/install/parabolaiso_loop_mnt
@@ -1,4 +1,6 @@
-#!/bin/bash
+#!/usr/bin/env bash
+#
+# SPDX-License-Identifier: GPL-3.0-or-later
build() {
add_runscript
@@ -9,5 +11,3 @@ cat<<HELPEOF
This hook loads the necessary modules for boot via loop device.
HELPEOF
}
-
-# vim: set ft=sh ts=4 sw=4 et:
diff --git a/parabolaiso/initcpio/install/parabolaiso_pxe_common b/parabolaiso/initcpio/install/parabolaiso_pxe_common
index eec9a7e..458fa69 100644
--- a/parabolaiso/initcpio/install/parabolaiso_pxe_common
+++ b/parabolaiso/initcpio/install/parabolaiso_pxe_common
@@ -1,4 +1,6 @@
-#!/bin/bash
+#!/usr/bin/env bash
+#
+# SPDX-License-Identifier: GPL-3.0-or-later
build() {
add_checked_modules -f "(irda|phy|wimax|wireless|ppp_|plip|pppoe)" "/drivers/net/"
@@ -8,13 +10,13 @@ build() {
add_binary /usr/lib/initcpio/ipconfig /bin/ipconfig
# Add hosts support files+dns
- add_symlink /usr/lib/libnss_files.so.2 $(readlink /usr/lib/libnss_files.so.2)
- add_binary $(readlink -f /usr/lib/libnss_files.so.2)
- add_symlink /usr/lib/libnss_dns.so.2 $(readlink /usr/lib/libnss_dns.so.2)
- add_binary $(readlink -f /usr/lib/libnss_dns.so.2)
+ add_symlink /usr/lib/libnss_files.so.2 "$(readlink /usr/lib/libnss_files.so.2)"
+ add_binary "$(readlink -f /usr/lib/libnss_files.so.2)"
+ add_symlink /usr/lib/libnss_dns.so.2 "$(readlink /usr/lib/libnss_dns.so.2)"
+ add_binary "$(readlink -f /usr/lib/libnss_dns.so.2)"
add_dir /etc
- echo "hosts: files dns" > $BUILDROOT/etc/nsswitch.conf
+ echo "hosts: files dns" > "$BUILDROOT/etc/nsswitch.conf"
}
help() {
@@ -22,5 +24,3 @@ cat<<HELPEOF
This hook loads the necessary modules for boot via PXE.
HELPEOF
}
-
-# vim: set ft=sh ts=4 sw=4 et:
diff --git a/parabolaiso/initcpio/install/parabolaiso_pxe_http b/parabolaiso/initcpio/install/parabolaiso_pxe_http
index 9ce9726..1e80852 100644
--- a/parabolaiso/initcpio/install/parabolaiso_pxe_http
+++ b/parabolaiso/initcpio/install/parabolaiso_pxe_http
@@ -1,11 +1,13 @@
-#!/bin/bash
+#!/usr/bin/env bash
+#
+# SPDX-License-Identifier: GPL-3.0-or-later
build() {
add_runscript
add_binary curl
- add_file $(readlink -f /etc/ssl/certs/ca-certificates.crt) /etc/ssl/certs/ca-certificates.crt
+ add_file "$(readlink -f /etc/ssl/certs/ca-certificates.crt)" /etc/ssl/certs/ca-certificates.crt
}
help() {
@@ -13,5 +15,3 @@ cat<<HELPEOF
This hook loads the necessary modules for boot via PXE and HTTP.
HELPEOF
}
-
-# vim: set ft=sh ts=4 sw=4 et:
diff --git a/parabolaiso/initcpio/install/parabolaiso_pxe_nbd b/parabolaiso/initcpio/install/parabolaiso_pxe_nbd
index 47d98ce..b4fb3b6 100644
--- a/parabolaiso/initcpio/install/parabolaiso_pxe_nbd
+++ b/parabolaiso/initcpio/install/parabolaiso_pxe_nbd
@@ -1,4 +1,6 @@
-#!/bin/bash
+#!/usr/bin/env bash
+#
+# SPDX-License-Identifier: GPL-3.0-or-later
build() {
add_module "nbd"
@@ -13,5 +15,3 @@ cat<<HELPEOF
This hook loads the necessary modules for boot via PXE and NBD.
HELPEOF
}
-
-# vim: set ft=sh ts=4 sw=4 et:
diff --git a/parabolaiso/initcpio/install/parabolaiso_pxe_nfs b/parabolaiso/initcpio/install/parabolaiso_pxe_nfs
index f8226e5..efd609d 100644
--- a/parabolaiso/initcpio/install/parabolaiso_pxe_nfs
+++ b/parabolaiso/initcpio/install/parabolaiso_pxe_nfs
@@ -1,4 +1,6 @@
-#!/bin/bash
+#!/usr/bin/env bash
+#
+# SPDX-License-Identifier: GPL-3.0-or-later
build() {
add_module "nfs"
@@ -13,5 +15,3 @@ help() {
This hook loads the necessary modules for boot via PXE and NFS.
HELPEOF
}
-
-# vim: set ft=sh ts=4 sw=4 et:
diff --git a/parabolaiso/initcpio/install/parabolaiso_shutdown b/parabolaiso/initcpio/install/parabolaiso_shutdown
index d7bffa7..f99c8c9 100644
--- a/parabolaiso/initcpio/install/parabolaiso_shutdown
+++ b/parabolaiso/initcpio/install/parabolaiso_shutdown
@@ -1,4 +1,6 @@
-#!/bin/bash
+#!/usr/bin/env bash
+#
+# SPDX-License-Identifier: GPL-3.0-or-later
build() {
add_binary cp
@@ -12,9 +14,7 @@ help() {
cat <<HELPEOF
This hook will create a shutdown initramfs in /run/initramfs
that we can pivot to on shutdown in order to unmount / and
-and others mount points, dm-snapshot devices and loopback devices.
-Mostly usefull for dm-snapshot persistent.
+and other mount points, dm-snapshot and loopback devices.
+Mostly useful for persistent dm-snapshot.
HELPEOF
}
-
-# vim: set ft=sh ts=4 sw=4 et:
diff --git a/parabolaiso/initcpio/script/parabolaiso_shutdown b/parabolaiso/initcpio/script/parabolaiso_shutdown
index 143df04..d12cd90 100644
--- a/parabolaiso/initcpio/script/parabolaiso_shutdown
+++ b/parabolaiso/initcpio/script/parabolaiso_shutdown
@@ -1,19 +1,21 @@
#!/bin/ash
+#
+# SPDX-License-Identifier: GPL-3.0-or-later
# /oldroot depends on things inside /oldroot/run/parabolaiso...
mkdir /oldrun
mount -n --move /oldroot/run /oldrun
# Unmount all mounts now.
-umount $(mount | awk '$3 ~/^\/oldroot/ {print $3}' | sort -r)
+umount "$(mount | awk '$3 ~/^\/oldroot/ {print $3}' | sort -r)"
# Remove all dm-snapshot devices.
dmsetup remove_all
# Remove all loopback devices.
for _lup in $(grep ^/dev/loop /oldrun/parabolaiso/used_block_devices | tac); do
- if ! losetup -d ${_lup} 2> /dev/null; then
- umount -d ${_lup}
+ if ! losetup -d -- "${_lup}" 2> /dev/null; then
+ umount -d -- "${_lup}"
fi
done
@@ -21,8 +23,8 @@ done
umount /oldrun/parabolaiso/cowspace
# Unmount boot device if needed (no copytoram=y used)
-if [[ ! -d /oldrun/parabolaiso/copytoram ]]; then
- if [[ -d /oldrun/parabolaiso/img_dev ]]; then
+if [ ! -d /oldrun/parabolaiso/copytoram ]; then
+ if [ -d /oldrun/parabolaiso/img_dev ]; then
umount /oldrun/parabolaiso/img_dev
else
umount /oldrun/parabolaiso/bootmnt
@@ -35,3 +37,5 @@ case "$1" in
reboot|poweroff|halt) "$1" -f ;;
*) halt -f;;
esac
+
+# vim: set ft=sh:
diff --git a/parabolaiso/mkparabolaiso b/parabolaiso/mkparabolaiso
index 751bd1e..f3a9765 100755
--- a/parabolaiso/mkparabolaiso
+++ b/parabolaiso/mkparabolaiso
@@ -1,4 +1,6 @@
#!/bin/bash
+#
+# SPDX-License-Identifier: GPL-3.0-or-later
set -e -u
@@ -43,13 +45,11 @@ _msg_error() {
}
_chroot_init() {
- local common="base syslinux linux-libre elogind libelogind"
-
mkdir -p ${work_dir}/airootfs
case $init in
- openrc) _pacman openrc-init $common ;;
- sysvinit) _pacman openrc-sysvinit $common ;;
- systemd) _pacman base syslinux linux-libre ;;
+ openrc) _pacman base syslinux openrc-init ;;
+ sysvinit) _pacman base syslinux openrc-sysvinit ;;
+ systemd) _pacman base syslinux ;;
esac
}
@@ -236,7 +236,7 @@ _mkairootfs_img () {
-comp "${sfs_comp}" -no-progress &> /dev/null
else
mksquashfs "${work_dir}/airootfs.img" "${work_dir}/iso/${install_dir}/${arch}/airootfs.sfs" -noappend \
- -comp "${sfs_comp}" -no-progress
+ -comp "${sfs_comp}"
fi
_msg_info "Done!"
rm "${work_dir}/airootfs.img"
@@ -255,7 +255,7 @@ _mkairootfs_sfs () {
-comp "${sfs_comp}" -no-progress &> /dev/null
else
mksquashfs "${work_dir}/airootfs" "${work_dir}/iso/${install_dir}/${arch}/airootfs.sfs" -noappend \
- -comp "${sfs_comp}" -no-progress
+ -comp "${sfs_comp}"
fi
_msg_info "Done!"
}